/* AutostartInfo.c generated by valac 0.50.2, the Vala compiler
 * generated from AutostartInfo.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define TYPE_AUTOSTART_INFO (autostart_info_get_type ())
typedef struct _AutostartInfo AutostartInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AutostartInfo {
	gchar* filename;
	gboolean visibility;
	gint delay;
	gchar* executable;
};

GType autostart_info_get_type (void) G_GNUC_CONST;
AutostartInfo* autostart_info_dup (const AutostartInfo* self);
void autostart_info_free (AutostartInfo* self);
void autostart_info_copy (const AutostartInfo* self,
                          AutostartInfo* dest);
void autostart_info_destroy (AutostartInfo* self);
gboolean autostart_info_is_launchable (AutostartInfo *self);
gchar* autostart_info_to_string (AutostartInfo *self);

gboolean
autostart_info_is_launchable (AutostartInfo *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if ((*self).visibility) {
		const gchar* _tmp1_;
		_tmp1_ = (*self).executable;
		_tmp0_ = _tmp1_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

gchar*
autostart_info_to_string (AutostartInfo *self)
{
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result = NULL;
	if (autostart_info_is_launchable (&(*self))) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp0_ = (*self).filename;
		_tmp1_ = string_to_string (_tmp0_);
		_tmp2_ = g_strdup_printf ("%i", (*self).delay);
		_tmp3_ = _tmp2_;
		_tmp4_ = (*self).executable;
		_tmp5_ = string_to_string (_tmp4_);
		_tmp6_ = g_strconcat (_tmp1_, ": Delayed by ", _tmp3_, " s | ", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp3_);
		result = _tmp7_;
		return result;
	}
	_tmp8_ = (*self).filename;
	_tmp9_ = string_to_string (_tmp8_);
	_tmp10_ = g_strconcat (_tmp9_, ": Ignored", NULL);
	result = _tmp10_;
	return result;
}

void
autostart_info_copy (const AutostartInfo* self,
                     AutostartInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).filename);
	(*dest).filename = _tmp1_;
	(*dest).visibility = (*self).visibility;
	(*dest).delay = (*self).delay;
	_tmp2_ = (*self).executable;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).executable);
	(*dest).executable = _tmp3_;
}

void
autostart_info_destroy (AutostartInfo* self)
{
	_g_free0 ((*self).filename);
	_g_free0 ((*self).executable);
}

AutostartInfo*
autostart_info_dup (const AutostartInfo* self)
{
	AutostartInfo* dup;
	dup = g_new0 (AutostartInfo, 1);
	autostart_info_copy (self, dup);
	return dup;
}

void
autostart_info_free (AutostartInfo* self)
{
	autostart_info_destroy (self);
	g_free (self);
}

static GType
autostart_info_get_type_once (void)
{
	GType autostart_info_type_id;
	autostart_info_type_id = g_boxed_type_register_static ("AutostartInfo", (GBoxedCopyFunc) autostart_info_dup, (GBoxedFreeFunc) autostart_info_free);
	return autostart_info_type_id;
}

GType
autostart_info_get_type (void)
{
	static volatile gsize autostart_info_type_id__volatile = 0;
	if (g_once_init_enter (&autostart_info_type_id__volatile)) {
		GType autostart_info_type_id;
		autostart_info_type_id = autostart_info_get_type_once ();
		g_once_init_leave (&autostart_info_type_id__volatile, autostart_info_type_id);
	}
	return autostart_info_type_id__volatile;
}

