/* ProgramLauncher.c generated by valac 0.50.2, the Vala compiler
 * generated from ProgramLauncher.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define TYPE_PROGRAM_LAUNCHER (program_launcher_get_type ())
#define PROGRAM_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROGRAM_LAUNCHER, ProgramLauncher))
#define PROGRAM_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROGRAM_LAUNCHER, ProgramLauncherClass))
#define IS_PROGRAM_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROGRAM_LAUNCHER))
#define IS_PROGRAM_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROGRAM_LAUNCHER))
#define PROGRAM_LAUNCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROGRAM_LAUNCHER, ProgramLauncherClass))

typedef struct _ProgramLauncher ProgramLauncher;
typedef struct _ProgramLauncherClass ProgramLauncherClass;
typedef struct _ProgramLauncherPrivate ProgramLauncherPrivate;

#define TYPE_AUTOSTART_INFO (autostart_info_get_type ())
typedef struct _AutostartInfo AutostartInfo;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecProgramLauncher ParamSpecProgramLauncher;

struct _ProgramLauncher {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ProgramLauncherPrivate * priv;
};

struct _ProgramLauncherClass {
	GTypeClass parent_class;
	void (*finalize) (ProgramLauncher *self);
};

struct _AutostartInfo {
	gchar* filename;
	gboolean visibility;
	gint delay;
	gchar* executable;
};

struct _ProgramLauncherPrivate {
	gint seconds;
	gboolean dry_run;
	GMainLoop* main_loop;
	GList* files;
};

struct _ParamSpecProgramLauncher {
	GParamSpec parent_instance;
};

static gint ProgramLauncher_private_offset;
static gpointer program_launcher_parent_class = NULL;

gpointer program_launcher_ref (gpointer instance);
void program_launcher_unref (gpointer instance);
GParamSpec* param_spec_program_launcher (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void value_set_program_launcher (GValue* value,
                                 gpointer v_object);
void value_take_program_launcher (GValue* value,
                                  gpointer v_object);
gpointer value_get_program_launcher (const GValue* value);
GType program_launcher_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ProgramLauncher, program_launcher_unref)
GType autostart_info_get_type (void) G_GNUC_CONST;
AutostartInfo* autostart_info_dup (const AutostartInfo* self);
void autostart_info_free (AutostartInfo* self);
void autostart_info_copy (const AutostartInfo* self,
                          AutostartInfo* dest);
void autostart_info_destroy (AutostartInfo* self);
static void _autostart_info_free0_ (gpointer var);
static inline void _g_list_free__autostart_info_free0_ (GList* self);
ProgramLauncher* program_launcher_new (gboolean dry_run);
ProgramLauncher* program_launcher_construct (GType object_type,
                                             gboolean dry_run);
void program_launcher_add (ProgramLauncher* self,
                           AutostartInfo* file);
gboolean autostart_info_is_launchable (AutostartInfo *self);
static gboolean program_launcher_runner (ProgramLauncher* self);
static void __lambda5_ (ProgramLauncher* self,
                 AutostartInfo* x);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
gint program_launcher_launch (ProgramLauncher* self);
static gboolean _program_launcher_runner_gsource_func (gpointer self);
static void program_launcher_finalize (ProgramLauncher * obj);
static GType program_launcher_get_type_once (void);

static inline gpointer
program_launcher_get_instance_private (ProgramLauncher* self)
{
	return G_STRUCT_MEMBER_P (self, ProgramLauncher_private_offset);
}

static void
_autostart_info_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (autostart_info_free (var), NULL));
}

static inline void
_g_list_free__autostart_info_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _autostart_info_free0_);
}

ProgramLauncher*
program_launcher_construct (GType object_type,
                            gboolean dry_run)
{
	ProgramLauncher* self = NULL;
	self = (ProgramLauncher*) g_type_create_instance (object_type);
	self->priv->dry_run = dry_run;
	return self;
}

ProgramLauncher*
program_launcher_new (gboolean dry_run)
{
	return program_launcher_construct (TYPE_PROGRAM_LAUNCHER, dry_run);
}

static gpointer
_autostart_info_dup0 (gpointer self)
{
	return self ? autostart_info_dup (self) : NULL;
}

void
program_launcher_add (ProgramLauncher* self,
                      AutostartInfo* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	if (autostart_info_is_launchable (file)) {
		AutostartInfo _tmp0_;
		AutostartInfo _tmp1_;
		AutostartInfo* _tmp2_;
		_tmp0_ = *file;
		_tmp1_ = _tmp0_;
		_tmp2_ = _autostart_info_dup0 (&_tmp1_);
		self->priv->files = g_list_append (self->priv->files, _tmp2_);
	}
}

static void
__lambda5_ (ProgramLauncher* self,
            AutostartInfo* x)
{
	GError* _inner_error0_ = NULL;
	if ((*x).delay == self->priv->seconds) {
		{
			if (self->priv->dry_run) {
				const gchar* _tmp0_;
				_tmp0_ = (*x).executable;
				g_message ("ProgramLauncher.vala:40: Time: %3d s | %s", self->priv->seconds, _tmp0_);
			} else {
				const gchar* _tmp1_;
				_tmp1_ = (*x).executable;
				g_spawn_command_line_async (_tmp1_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_SPAWN_ERROR) {
						goto __catch0_g_spawn_error;
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		goto __finally0;
		__catch0_g_spawn_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			g_warning ("ProgramLauncher.vala:46: Error launching: %s", _tmp3_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->files = g_list_remove (self->priv->files, x);
	}
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda5_ ((ProgramLauncher*) self, (AutostartInfo*) data);
}

static gboolean
program_launcher_runner (ProgramLauncher* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	gint _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->files;
	g_list_foreach (_tmp0_, ___lambda5__gfunc, self);
	_tmp1_ = self->priv->files;
	if (g_list_length (_tmp1_) == ((guint) 0)) {
		GMainLoop* _tmp2_;
		_tmp2_ = self->priv->main_loop;
		g_main_loop_quit (_tmp2_);
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->seconds;
	self->priv->seconds = _tmp3_ + 1;
	result = TRUE;
	return result;
}

static gboolean
_program_launcher_runner_gsource_func (gpointer self)
{
	gboolean result;
	result = program_launcher_runner ((ProgramLauncher*) self);
	return result;
}

gint
program_launcher_launch (ProgramLauncher* self)
{
	gint _tmp0_ = 0;
	gint delay = 0;
	GMainLoop* _tmp1_;
	GMainLoop* _tmp2_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->dry_run) {
		_tmp0_ = 0;
	} else {
		_tmp0_ = 1;
	}
	delay = _tmp0_;
	_tmp1_ = g_main_loop_new (NULL, FALSE);
	_g_main_loop_unref0 (self->priv->main_loop);
	self->priv->main_loop = _tmp1_;
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) delay, _program_launcher_runner_gsource_func, program_launcher_ref (self), program_launcher_unref);
	_tmp2_ = self->priv->main_loop;
	g_main_loop_run (_tmp2_);
	result = 0;
	return result;
}

static void
value_program_launcher_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_program_launcher_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		program_launcher_unref (value->data[0].v_pointer);
	}
}

static void
value_program_launcher_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = program_launcher_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_program_launcher_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_program_launcher_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		ProgramLauncher * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = program_launcher_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_program_launcher_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	ProgramLauncher ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = program_launcher_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_program_launcher (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecProgramLauncher* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PROGRAM_LAUNCHER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_program_launcher (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROGRAM_LAUNCHER), NULL);
	return value->data[0].v_pointer;
}

void
value_set_program_launcher (GValue* value,
                            gpointer v_object)
{
	ProgramLauncher * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROGRAM_LAUNCHER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROGRAM_LAUNCHER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		program_launcher_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		program_launcher_unref (old);
	}
}

void
value_take_program_launcher (GValue* value,
                             gpointer v_object)
{
	ProgramLauncher * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROGRAM_LAUNCHER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROGRAM_LAUNCHER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		program_launcher_unref (old);
	}
}

static void
program_launcher_class_init (ProgramLauncherClass * klass,
                             gpointer klass_data)
{
	program_launcher_parent_class = g_type_class_peek_parent (klass);
	((ProgramLauncherClass *) klass)->finalize = program_launcher_finalize;
	g_type_class_adjust_private_offset (klass, &ProgramLauncher_private_offset);
}

static void
program_launcher_instance_init (ProgramLauncher * self,
                                gpointer klass)
{
	self->priv = program_launcher_get_instance_private (self);
	self->priv->seconds = 0;
	self->priv->files = NULL;
	self->ref_count = 1;
}

static void
program_launcher_finalize (ProgramLauncher * obj)
{
	ProgramLauncher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROGRAM_LAUNCHER, ProgramLauncher);
	g_signal_handlers_destroy (self);
	_g_main_loop_unref0 (self->priv->main_loop);
	(self->priv->files == NULL) ? NULL : (self->priv->files = (_g_list_free__autostart_info_free0_ (self->priv->files), NULL));
}

static GType
program_launcher_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_program_launcher_init, value_program_launcher_free_value, value_program_launcher_copy_value, value_program_launcher_peek_pointer, "p", value_program_launcher_collect_value, "p", value_program_launcher_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ProgramLauncherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) program_launcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ProgramLauncher), 0, (GInstanceInitFunc) program_launcher_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType program_launcher_type_id;
	program_launcher_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ProgramLauncher", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ProgramLauncher_private_offset = g_type_add_instance_private (program_launcher_type_id, sizeof (ProgramLauncherPrivate));
	return program_launcher_type_id;
}

GType
program_launcher_get_type (void)
{
	static volatile gsize program_launcher_type_id__volatile = 0;
	if (g_once_init_enter (&program_launcher_type_id__volatile)) {
		GType program_launcher_type_id;
		program_launcher_type_id = program_launcher_get_type_once ();
		g_once_init_leave (&program_launcher_type_id__volatile, program_launcher_type_id);
	}
	return program_launcher_type_id__volatile;
}

gpointer
program_launcher_ref (gpointer instance)
{
	ProgramLauncher * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
program_launcher_unref (gpointer instance)
{
	ProgramLauncher * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PROGRAM_LAUNCHER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

